{-#LANGUAGE FlexibleInstances,MultiParamTypeClasses,StandaloneDeriving#-}

module BST_QuickSpec where

import BST
import QuickSpec

type BSTII = BST Int Integer

deriving instance (Ord k, Ord v) => Ord (BST k v)

instance (Ord k, Ord v) => Observe () [(k,v)] (BST k v) where
  observe () = toList

main = quickSpec [
         monoTypeObserve (Proxy :: Proxy BSTII),
	 background [
	   con "Nothing" (Nothing :: Maybe Integer),
	   con "Just"    (Just    :: Integer -> Maybe Integer),
	   predicate "/=" ((/=) :: Int -> Int -> Bool)
	   ],
	 
	   con "nil"    (nil  :: BSTII),
	   con "find"   (find :: Int -> BSTII -> Maybe Integer),
	   con "insert" (insert :: Int -> Integer -> BSTII -> BSTII)
       ]
       